<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: inc/coopBendersAlgorithm.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_bfccd401955b95cf8c75461437045ac0.html">inc</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">coopBendersAlgorithm.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="coop_benders_algorithm_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**********************************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2021 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * This program and the accompanying materials are made available under the</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> **********************************************************************************/</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;gurobi_c++.h&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//#include &lt;ctime&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="coop_benders_subproblem_c_w_8hpp.html">coopBendersSubproblemCW.hpp</a>&quot;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="coop_benders_subproblem_l1_8hpp.html">coopBendersSubproblemL1.hpp</a>&quot;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="input_structs_8hpp.html">inputStructs.hpp</a>&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="plantbus_info_8hpp.html">plantbusInfo.hpp</a>&quot;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;variant&gt;</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="namespacedecoop.html">   31</a></span>&#160;<span class="keyword">namespace </span>decoop {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html">   36</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdecoop_1_1_coop_benders_algorithm.html">CoopBendersAlgorithm</a> {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ab872e4a876ba7e0a224a901e0f86a29f">   38</a></span>&#160;        <span class="keyword">using</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab872e4a876ba7e0a224a901e0f86a29f">SubVariant</a> = std::variant&lt;PlantbusSubproblemCW, PlantbusSubproblemL1&gt;;                            </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">   39</a></span>&#160;        <span class="keyword">using</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> = std::vector&lt;std::variant&lt;PlantbusSubproblemCW, PlantbusSubproblemL1&gt;&gt;::iterator;    </div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">   40</a></span>&#160;        <span class="keyword">using</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> = std::chrono::time_point&lt;std::chrono::steady_clock&gt;;                                   </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    </div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ae57276e89bdb013509f1e93d80432c58">   45</a></span>&#160;        <span class="keyword">enum class</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ae57276e89bdb013509f1e93d80432c58">SubproblemType</a> { kCWSubproblem, kL1Subproblem };</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a8928a7986ffa37f37e0bfc4523770897">   47</a></span>&#160;        std::vector&lt;GRBEnv&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a8928a7986ffa37f37e0bfc4523770897">environments_</a>;                              </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a2cf621a6dc5cc81e7b5e27490931c87d">   48</a></span>&#160;        <span class="keyword">const</span> <a class="code" href="structdecoop_1_1_algorithm_options.html">AlgorithmOptions</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a2cf621a6dc5cc81e7b5e27490931c87d">options_</a>;                                </div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a461c344096dee52120b02779607a81f6">   49</a></span>&#160;        GRBModel <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a461c344096dee52120b02779607a81f6">fixed_model_</a>;                                          </div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a851caba22a1246d0878ad1e20890bda6">   50</a></span>&#160;        GRBModel <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a851caba22a1246d0878ad1e20890bda6">master_model_</a>;                                         </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#aeaf2c2f27523416866e27ce5d591fd4f">   52</a></span>&#160;        <span class="keyword">const</span> std::vector&lt;std::pair&lt;int, double&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aeaf2c2f27523416866e27ce5d591fd4f">plantbusses_</a>;         </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a03c901da8d2613290d2bcf817d0cf8f1">   53</a></span>&#160;        std::vector&lt;std::vector&lt;GRBVar&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a03c901da8d2613290d2bcf817d0cf8f1">fx_p_plant_var_</a>;               </div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a84b98519deb53dfe9d3f12c4f2c30550">   54</a></span>&#160;        std::vector&lt;std::vector&lt;GRBVar&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a84b98519deb53dfe9d3f12c4f2c30550">master_p_plant_var_</a>;           </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="comment">//sub problem</span></div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#aa0df6429c2226e849c6afe0ed66962b2">   57</a></span>&#160;        std::vector&lt;SubVariant&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aa0df6429c2226e849c6afe0ed66962b2">sub_prob_</a>;                              </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#abb7a97bf70acb0771e469e02e15603c5">   58</a></span>&#160;        std::vector&lt;PlantbusInfo&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#abb7a97bf70acb0771e469e02e15603c5">pb_info_</a>;                             </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#afaeae39b360e35b2060e832f31b39468">   59</a></span>&#160;        std::vector&lt;std::vector&lt;double&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#afaeae39b360e35b2060e832f31b39468">last_primary_feas_sol_</a>;        </div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#acb6202f0b7f4bc762002223e703cec3e">   60</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#acb6202f0b7f4bc762002223e703cec3e">cw_begin_</a>;                                          </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#abbf502dd6502fe9f13099f4279f35f78">   61</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#abbf502dd6502fe9f13099f4279f35f78">cw_end_</a>;                                            </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a1cc13444151f4ebccfa1294137e977ba">   62</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a1cc13444151f4ebccfa1294137e977ba">l1_begin_</a>;                                          </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a38b1314f6931ffcb25160a7dd95cbf0e">   63</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a38b1314f6931ffcb25160a7dd95cbf0e">l1_end_</a>;                                            </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#aab973a4391362d9e4bfd62a1c749c992">   64</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aab973a4391362d9e4bfd62a1c749c992">feas_begin_</a>;                                        </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a752f3c5170f49ca5439f3cf214af7e56">   65</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a752f3c5170f49ca5439f3cf214af7e56">feas_end_</a>;                                          </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#af448bfec721290a085e5838574f80591">   66</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#af448bfec721290a085e5838574f80591">secondary_begin_</a>;                                   </div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a4c91e62375c1b3fb2bdefd25eed747f6">   67</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">SubIterator</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a4c91e62375c1b3fb2bdefd25eed747f6">secondary_end_</a>;                                     </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="comment">//output</span></div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a743c11d60445ad3e06b568c3edfde40e">   70</a></span>&#160;        std::ofstream&amp; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a743c11d60445ad3e06b568c3edfde40e">out_file_</a>;                                       </div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a1dd0c07223c7153d4054edf730b3ff8b">   71</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a1dd0c07223c7153d4054edf730b3ff8b">num_timesteps_</a>;                                  </div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#aa8d7a3c3def380194aa810c3bb131634">   72</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aa8d7a3c3def380194aa810c3bb131634">final_iters_</a>;                                               </div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a9e8507813e2333f2194dc191cbc1b18e">   73</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a9e8507813e2333f2194dc191cbc1b18e">tau_</a>;                                                    </div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a792854e54bf5ef487e0249dae0b559e2">   74</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a792854e54bf5ef487e0249dae0b559e2">tot_flex_power_</a>;                                   </div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a662b2c852f4d89685c0424de36662196">   75</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a662b2c852f4d89685c0424de36662196">detectable_opt_gap_</a>;                                     </div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a04ce878ed930f13a1d0c3f6437d8aa6e">   76</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a04ce878ed930f13a1d0c3f6437d8aa6e">accepted_cost_</a>;                                          </div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a79e4be92dd47da7c8f53a739163cbde0">   77</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a79e4be92dd47da7c8f53a739163cbde0">cumul_feas_dist_</a>;                                        </div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#adc5adac8356e59a301f9a3e8ce062659">   78</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#adc5adac8356e59a301f9a3e8ce062659">coop_sol_cost_</a>;                                          </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ac68e0694ba0edf51459909d03c520ac0">   80</a></span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ac68e0694ba0edf51459909d03c520ac0">time_master_stage_</a>;                   </div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#afe2b949283c56ad246f1bfe6827d94ec">   81</a></span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#afe2b949283c56ad246f1bfe6827d94ec">time_feas_pt_stage_</a>;                  </div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a8b75829a04934eb6c75fdb8849958bea">   82</a></span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a8b75829a04934eb6c75fdb8849958bea">time_sub_stage_</a>;                      </div>
<div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ac360a0d07a61e7d722d0f0e5f0c48114">   83</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ac360a0d07a61e7d722d0f0e5f0c48114">mas_t_</a>;                                               </div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#afdcd354b4cc768b04f23061ce283fe61">   84</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#afdcd354b4cc768b04f23061ce283fe61">fpt_t_</a>;                                               </div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a43a1614812a29d730257cf166f36ac30">   85</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a43a1614812a29d730257cf166f36ac30">sub_t_</a>;                                               </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a945b1012a8ad61d60715c37cce70349f">   87</a></span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a945b1012a8ad61d60715c37cce70349f">time_sub_solving_</a>;                    </div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a560de44bf20cf42b93efd2abae4f3e1d">   88</a></span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a560de44bf20cf42b93efd2abae4f3e1d">time_sub_cutgen_</a>;                     </div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#ade27eb3be65e5ba3fbf436454fb1a0e4">   89</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ade27eb3be65e5ba3fbf436454fb1a0e4">sub_solve_t_</a>;                                         </div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a4d112a3a98269ffef46c6b7c17435858">   90</a></span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">TimePoint</a> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a4d112a3a98269ffef46c6b7c17435858">sub_cutgen_t_</a>;                                        </div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a1366732fe42398feff835ff2ef263555">   91</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a1366732fe42398feff835ff2ef263555">converged_</a>;                                                </div>
<div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classdecoop_1_1_coop_benders_algorithm.html#a46f9fb3764cd041717fda27e7b80222a">   92</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a46f9fb3764cd041717fda27e7b80222a">coop_sol_available_</a>;                                 </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab5ccc3ab6f717685c575d48d757afaa7">SetUpMasterAndFixed</a>();</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ada78f67d99bcf463c0bc313ba5bc2908">SetUpSub</a>(<span class="keyword">const</span> std::string&amp; workspace_path, <span class="keyword">const</span> std::unordered_map&lt;int, double&gt;&amp; bus_data);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#afa5055545de115444304ee759e6cc27b">SubStage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a668621af4dcf6c6826d5eba7b5715c11">FeasPtStage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a2c28b6d3229dba305cb1f591d463752d">MasterStage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration);</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a7b56e51ff3e92335cdabc630652ccfce">SolveParallel</a>(<span class="keyword">const</span> std::vector&lt;std::pair&lt;SubIterator, SubIterator&gt;&gt;&amp; iterators);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a328ca9773c8a16d2eb691ebcede82779">SolveSerial</a>(<span class="keyword">const</span> std::vector&lt;std::pair&lt;SubIterator, SubIterator&gt;&gt;&amp; iterators);</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a5cd869b4eacbf161ad1cd4268d35e33e">GenerateCut</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration, <span class="keyword">const</span> std::vector&lt;std::pair&lt;SubIterator, SubIterator&gt;&gt;&amp; iterators);</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a80d984bf244a72abf9813888546840a8">GenerateCutParallel</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration, <span class="keyword">const</span> std::vector&lt;std::pair&lt;SubIterator, SubIterator&gt;&gt;&amp; iterators);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a8d27a3623a0151e24e4bb170e7e056dc">SolveAndGenerateCutParallel</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration, <span class="keyword">const</span> std::vector&lt;std::pair&lt;SubIterator, SubIterator&gt;&gt;&amp; iterators);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a2fda073032c513522de1419fcad7411b">UpdatePowSugg</a>();</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a40fed2e5a31289fc5fb613d532df2711">CreateSubproblemObjects</a>(<span class="keyword">const</span> std::string&amp; workspace_path, <span class="keyword">const</span> std::unordered_map&lt;int, double&gt;&amp; bus_data, <span class="keyword">const</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ae57276e89bdb013509f1e93d80432c58">SubproblemType</a> sp_type, <span class="keyword">const</span> <span class="keywordtype">bool</span> add_environments);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a3965b5a7b5a8772fbec67443c8403561">PrintSubproblemObjectivesAndDistances</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> iteration);</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a082bcb0b1e8b840a3daf2462b2a77d49">CoopBendersAlgorithm</a>(</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            std::ofstream&amp; out, <span class="keyword">const</span> std::string&amp; workspace_path, <span class="keywordtype">unsigned</span> timesteps,</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="keyword">const</span> std::vector&lt;std::pair&lt;int, double&gt;&gt;&amp; plantbusses, <span class="keyword">const</span> std::unordered_map&lt;int, double&gt;&amp; bus_data,</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">bool</span> coop_sol_available = <span class="keyword">false</span>, <span class="keyword">const</span> <span class="keywordtype">double</span> coop_sol_cost = 0</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        );</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a7f1f5049a7a71ab722dca7e17626e758">Iterate</a>();</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        std::vector&lt;std::vector&lt;GRBVar&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a065e115d4abb5e7953d9565b5128eeaf">get_master_p_plant_var</a>();</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        std::vector&lt;std::pair&lt;int, double&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a161b395f2c580613c8125462742a328a">GetPlantbus</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <span class="keywordtype">unsigned</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#abb47e102a47591ccadccb6240f829f1f">get_num_timesteps</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        GRBModel&amp; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a8fed8b5589c555795bc04c257f96a502">get_fixed_model</a>();</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        std::vector&lt;SubVariant&gt;&amp; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aada3fc86152b59626fffa6b3dc68fe5d">ProvideSubproblemVec</a>();</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        std::vector&lt;PlantbusInfo&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a4da41d025e2f42ac7a5e1d94e64a7124">get_pb_info</a>();</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        std::vector&lt;std::vector&lt;double&gt;&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a85b6f17e8cbf3a1ca8185c200a6a41bd">GetFixedPPlant</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a587ccaaa37aa0c85e2d9975c6e2411ea">get_converged</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a105c1b42dfedd9ee5898844421debf7d">get_time_master_stage</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a5a27c785922631e08e5d8bd3fe729d88">get_time_sub_stage</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#ab7e6d0dcd9651712b1f047716bb4a4eb">get_time_feas_pt_stage</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a025ed34f322183043be8ac4026d42334">get_time_sub_solving</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        std::chrono::duration&lt;double&gt; <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a812e51690eef89b5cf1a3a9eb2290f59">get_time_sub_cutgen</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#aabf3a8b928c41ed94cd2245d55e62015">get_tot_flex_power</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a5c3efb6d12ba6b388925891b1a93cd77">get_tau</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a2644af07a16176cbc6605a44d9306804">get_final_iters</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a525aec2b531f79d2f9703c20030a25ff">get_detectable_opt_gap</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a75f36dfd4cf8b3aa8f8f35a9eaff9dbd">get_accepted_cost</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a6cb573720b0dfe705555e2bcd4d31e2d">GetInitialTau</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a540f008024261b38b98d756a75f1e5e1">GetAcceptableGap</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_coop_benders_algorithm.html#a90848269dce6641b7a01e1edaee8a151">PrintActiveCuts</a>();</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    };</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div>
<div class="line"><a name="l00359"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html">  359</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdecoop_1_1_price_problem.html">PriceProblem</a> {</div>
<div class="line"><a name="l00360"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#a3a2a06aa945eaaadaa80a814bd8187ce">  360</a></span>&#160;        GRBEnv <a class="code" href="classdecoop_1_1_price_problem.html#a3a2a06aa945eaaadaa80a814bd8187ce">price_env_</a>;                                      </div>
<div class="line"><a name="l00361"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3">  361</a></span>&#160;        GRBModel <a class="code" href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3">loadflow_price_</a>;                               </div>
<div class="line"><a name="l00362"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#a8a4e0ef0a28b311a50ed9d42c9a24b5e">  362</a></span>&#160;        <a class="code" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper&lt;GRBVar&gt;</a> <a class="code" href="classdecoop_1_1_price_problem.html#a8a4e0ef0a28b311a50ed9d42c9a24b5e">price_vars_</a>;                </div>
<div class="line"><a name="l00363"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#a3fbdc2d0f7bdfb301539ca6cde9dd891">  363</a></span>&#160;        std::vector&lt;std::pair&lt;int, double&gt;&gt; <a class="code" href="classdecoop_1_1_price_problem.html#a3fbdc2d0f7bdfb301539ca6cde9dd891">plantbusses_</a>;       </div>
<div class="line"><a name="l00364"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#ad4bebc3c8d302de0ac70da6ac1f5f61d">  364</a></span>&#160;        <span class="keywordtype">unsigned</span> <a class="code" href="classdecoop_1_1_price_problem.html#ad4bebc3c8d302de0ac70da6ac1f5f61d">timesteps_</a>;                                    </div>
<div class="line"><a name="l00365"></a><span class="lineno"><a class="line" href="classdecoop_1_1_price_problem.html#a1087bd9f6bb169778232ec7f8d634b7b">  365</a></span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_price_problem.html#a1087bd9f6bb169778232ec7f8d634b7b">sbase_</a>;                                          </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        <a class="code" href="classdecoop_1_1_price_problem.html#aad9dac4ba44148d0a7f9cc632f000634">PriceProblem</a>(<span class="keyword">const</span> std::string&amp; lp_file, <span class="keyword">const</span> std::vector&lt;std::pair&lt;int, double&gt;&gt;&amp; plantbusses, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> timesteps, <span class="keyword">const</span> <span class="keywordtype">double</span> sbase);</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_price_problem.html#a047cfe9673eaa2e1182bf0c1efb969b7">ComputePrices</a>(<span class="keyword">const</span> std::unordered_map&lt;int, double&gt;&amp; bus_data, <span class="keyword">const</span> std::unordered_map&lt;std::string, double&gt;&amp; wd, GRBModel&amp; loadflow_in);</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        std::vector&lt;std::vector&lt;double&gt;&gt; <a class="code" href="classdecoop_1_1_price_problem.html#a1f4640f81b1c48a07adca7278d16ff79">GetPrices</a>();</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_price_problem.html#a672a45fd289487496972167b1b55f7f9">ComputeAndPrintCongestionCost</a>(std::ofstream&amp; out_file, std::string&amp;&amp; setup);</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    };</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;} <span class="comment">//namespace decoop</span></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a9e8507813e2333f2194dc191cbc1b18e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a9e8507813e2333f2194dc191cbc1b18e">decoop::CoopBendersAlgorithm::tau_</a></div><div class="ttdeci">double tau_</div><div class="ttdoc">Current feasibility threshold. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:73</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a1cc13444151f4ebccfa1294137e977ba"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a1cc13444151f4ebccfa1294137e977ba">decoop::CoopBendersAlgorithm::l1_begin_</a></div><div class="ttdeci">SubIterator l1_begin_</div><div class="ttdoc">Iterator to beginning of primary L1 problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:62</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a80d984bf244a72abf9813888546840a8"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a80d984bf244a72abf9813888546840a8">decoop::CoopBendersAlgorithm::GenerateCutParallel</a></div><div class="ttdeci">void GenerateCutParallel(const int iteration, const std::vector&lt; std::pair&lt; SubIterator, SubIterator &gt;&gt; &amp;iterators)</div><div class="ttdoc">Generates cuts for specified subproblems in parallel. </div><div class="ttdef"><b>Definition:</b> coopBendersSolveNCutgen.cpp:120</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a8fed8b5589c555795bc04c257f96a502"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a8fed8b5589c555795bc04c257f96a502">decoop::CoopBendersAlgorithm::get_fixed_model</a></div><div class="ttdeci">GRBModel &amp; get_fixed_model()</div><div class="ttdoc">Returns reference to model with fixed cooperating loads. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:437</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a082bcb0b1e8b840a3daf2462b2a77d49"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a082bcb0b1e8b840a3daf2462b2a77d49">decoop::CoopBendersAlgorithm::CoopBendersAlgorithm</a></div><div class="ttdeci">CoopBendersAlgorithm(std::ofstream &amp;out, const std::string &amp;workspace_path, unsigned timesteps, const std::vector&lt; std::pair&lt; int, double &gt;&gt; &amp;plantbusses, const std::unordered_map&lt; int, double &gt; &amp;bus_data, const bool coop_sol_available=false, const double coop_sol_cost=0)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:362</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a8928a7986ffa37f37e0bfc4523770897"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a8928a7986ffa37f37e0bfc4523770897">decoop::CoopBendersAlgorithm::environments_</a></div><div class="ttdeci">std::vector&lt; GRBEnv &gt; environments_</div><div class="ttdoc">Vector holding all GRBEnv objects. One entry is needed per thread, so generally, this will have one e...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:47</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aada3fc86152b59626fffa6b3dc68fe5d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aada3fc86152b59626fffa6b3dc68fe5d">decoop::CoopBendersAlgorithm::ProvideSubproblemVec</a></div><div class="ttdeci">std::vector&lt; SubVariant &gt; &amp; ProvideSubproblemVec()</div><div class="ttdoc">Returns reference to vector containing all subproblems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:441</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a2c28b6d3229dba305cb1f591d463752d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a2c28b6d3229dba305cb1f591d463752d">decoop::CoopBendersAlgorithm::MasterStage</a></div><div class="ttdeci">void MasterStage(const int iteration)</div><div class="ttdoc">Solves master OPF problem and makes a new power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:320</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a7b56e51ff3e92335cdabc630652ccfce"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a7b56e51ff3e92335cdabc630652ccfce">decoop::CoopBendersAlgorithm::SolveParallel</a></div><div class="ttdeci">void SolveParallel(const std::vector&lt; std::pair&lt; SubIterator, SubIterator &gt;&gt; &amp;iterators)</div><div class="ttdoc">Solves specified subproblems in parallel. </div><div class="ttdef"><b>Definition:</b> coopBendersSolveNCutgen.cpp:22</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a065e115d4abb5e7953d9565b5128eeaf"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a065e115d4abb5e7953d9565b5128eeaf">decoop::CoopBendersAlgorithm::get_master_p_plant_var</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; GRBVar &gt; &gt; get_master_p_plant_var()</div><div class="ttdoc">Returns power profiles for all cooperating busses suggested by the master problem. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:425</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a3965b5a7b5a8772fbec67443c8403561"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a3965b5a7b5a8772fbec67443c8403561">decoop::CoopBendersAlgorithm::PrintSubproblemObjectivesAndDistances</a></div><div class="ttdeci">void PrintSubproblemObjectivesAndDistances(const int iteration)</div><div class="ttdoc">Writes objective value and feasibility distance for each subproblem to output file. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:341</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_acb6202f0b7f4bc762002223e703cec3e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#acb6202f0b7f4bc762002223e703cec3e">decoop::CoopBendersAlgorithm::cw_begin_</a></div><div class="ttdeci">SubIterator cw_begin_</div><div class="ttdoc">Iterator to beginning of primary CW problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:60</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a752f3c5170f49ca5439f3cf214af7e56"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a752f3c5170f49ca5439f3cf214af7e56">decoop::CoopBendersAlgorithm::feas_end_</a></div><div class="ttdeci">SubIterator feas_end_</div><div class="ttdoc">Iterator to end of problems used for computing feasibility distance in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:65</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_abbf502dd6502fe9f13099f4279f35f78"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#abbf502dd6502fe9f13099f4279f35f78">decoop::CoopBendersAlgorithm::cw_end_</a></div><div class="ttdeci">SubIterator cw_end_</div><div class="ttdoc">Iterator to end of primary CW problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:61</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aeaf2c2f27523416866e27ce5d591fd4f"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aeaf2c2f27523416866e27ce5d591fd4f">decoop::CoopBendersAlgorithm::plantbusses_</a></div><div class="ttdeci">const std::vector&lt; std::pair&lt; int, double &gt; &gt; plantbusses_</div><div class="ttdoc">Contains bus numbers of cooperating busses as well as flexible load fractions. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:52</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_af448bfec721290a085e5838574f80591"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#af448bfec721290a085e5838574f80591">decoop::CoopBendersAlgorithm::secondary_begin_</a></div><div class="ttdeci">SubIterator secondary_begin_</div><div class="ttdoc">Iterator to beginning of secondary problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:66</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a1dd0c07223c7153d4054edf730b3ff8b"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a1dd0c07223c7153d4054edf730b3ff8b">decoop::CoopBendersAlgorithm::num_timesteps_</a></div><div class="ttdeci">const unsigned num_timesteps_</div><div class="ttdoc">Number of timesteps in the model. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:71</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ade27eb3be65e5ba3fbf436454fb1a0e4"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ade27eb3be65e5ba3fbf436454fb1a0e4">decoop::CoopBendersAlgorithm::sub_solve_t_</a></div><div class="ttdeci">TimePoint sub_solve_t_</div><div class="ttdoc">Time at which solving of subproblems is started during a single subproblem stage. ...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:89</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a1f4640f81b1c48a07adca7278d16ff79"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a1f4640f81b1c48a07adca7278d16ff79">decoop::PriceProblem::GetPrices</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; double &gt; &gt; GetPrices()</div><div class="ttdoc">Gets previously computed electricity prices at each bus. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:578</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a1087bd9f6bb169778232ec7f8d634b7b"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a1087bd9f6bb169778232ec7f8d634b7b">decoop::PriceProblem::sbase_</a></div><div class="ttdeci">double sbase_</div><div class="ttdoc">Per-unit base. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:365</div></div>
<div class="ttc" id="input_structs_8hpp_html"><div class="ttname"><a href="input_structs_8hpp.html">inputStructs.hpp</a></div><div class="ttdoc">Header file for structs used to process user input from option files. </div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a161b395f2c580613c8125462742a328a"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a161b395f2c580613c8125462742a328a">decoop::CoopBendersAlgorithm::GetPlantbus</a></div><div class="ttdeci">std::vector&lt; std::pair&lt; int, double &gt; &gt; GetPlantbus() const </div><div class="ttdoc">Returns plantbusses and flexible load fractions. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:429</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ab7e6d0dcd9651712b1f047716bb4a4eb"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ab7e6d0dcd9651712b1f047716bb4a4eb">decoop::CoopBendersAlgorithm::get_time_feas_pt_stage</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; get_time_feas_pt_stage() const </div><div class="ttdoc">Returns total time spent finding feasible points. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:481</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a587ccaaa37aa0c85e2d9975c6e2411ea"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a587ccaaa37aa0c85e2d9975c6e2411ea">decoop::CoopBendersAlgorithm::get_converged</a></div><div class="ttdeci">bool get_converged() const </div><div class="ttdoc">Returns whether or not the algorithm converged within the allocated maximum number of iterations...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:469</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_aad9dac4ba44148d0a7f9cc632f000634"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#aad9dac4ba44148d0a7f9cc632f000634">decoop::PriceProblem::PriceProblem</a></div><div class="ttdeci">PriceProblem(const std::string &amp;lp_file, const std::vector&lt; std::pair&lt; int, double &gt;&gt; &amp;plantbusses, const unsigned timesteps, const double sbase)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:537</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a2644af07a16176cbc6605a44d9306804"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a2644af07a16176cbc6605a44d9306804">decoop::CoopBendersAlgorithm::get_final_iters</a></div><div class="ttdeci">int get_final_iters() const </div><div class="ttdoc">Returns total number of iterations performed. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:501</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a85b6f17e8cbf3a1ca8185c200a6a41bd"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a85b6f17e8cbf3a1ca8185c200a6a41bd">decoop::CoopBendersAlgorithm::GetFixedPPlant</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; double &gt; &gt; GetFixedPPlant() const </div><div class="ttdoc">Returns the power profiles set in the fixed model. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:449</div></div>
<div class="ttc" id="coop_benders_subproblem_l1_8hpp_html"><div class="ttname"><a href="coop_benders_subproblem_l1_8hpp.html">coopBendersSubproblemL1.hpp</a></div><div class="ttdoc">Header file for PlantbusSubproblemL1 class. </div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_afdcd354b4cc768b04f23061ce283fe61"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#afdcd354b4cc768b04f23061ce283fe61">decoop::CoopBendersAlgorithm::fpt_t_</a></div><div class="ttdeci">TimePoint fpt_t_</div><div class="ttdoc">Time at which a feasible point finding stage is started. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:84</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_afaeae39b360e35b2060e832f31b39468"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#afaeae39b360e35b2060e832f31b39468">decoop::CoopBendersAlgorithm::last_primary_feas_sol_</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; double &gt; &gt; last_primary_feas_sol_</div><div class="ttdoc">Holds last iteration&amp;#39;s feasible power profiles as determined by subproblems. Used for generating new ...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:59</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a743c11d60445ad3e06b568c3edfde40e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a743c11d60445ad3e06b568c3edfde40e">decoop::CoopBendersAlgorithm::out_file_</a></div><div class="ttdeci">std::ofstream &amp; out_file_</div><div class="ttdoc">Reference to output txt file object, for writing iteration updates. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:70</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_adc5adac8356e59a301f9a3e8ce062659"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#adc5adac8356e59a301f9a3e8ce062659">decoop::CoopBendersAlgorithm::coop_sol_cost_</a></div><div class="ttdeci">double coop_sol_cost_</div><div class="ttdoc">Cost of the cooperative (i.e. integrated) solution. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:78</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a8b75829a04934eb6c75fdb8849958bea"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a8b75829a04934eb6c75fdb8849958bea">decoop::CoopBendersAlgorithm::time_sub_stage_</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; time_sub_stage_</div><div class="ttdoc">Total subproblem stage time. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:82</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a668621af4dcf6c6826d5eba7b5715c11"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a668621af4dcf6c6826d5eba7b5715c11">decoop::CoopBendersAlgorithm::FeasPtStage</a></div><div class="ttdeci">void FeasPtStage(const int iteration)</div><div class="ttdoc">Computes an upper bound to OPF cost. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:229</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a540f008024261b38b98d756a75f1e5e1"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a540f008024261b38b98d756a75f1e5e1">decoop::CoopBendersAlgorithm::GetAcceptableGap</a></div><div class="ttdeci">double GetAcceptableGap() const </div><div class="ttdoc">Returns acceptable optimality gap as specified in option file. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:518</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a672a45fd289487496972167b1b55f7f9"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a672a45fd289487496972167b1b55f7f9">decoop::PriceProblem::ComputeAndPrintCongestionCost</a></div><div class="ttdeci">double ComputeAndPrintCongestionCost(std::ofstream &amp;out_file, std::string &amp;&amp;setup)</div><div class="ttdoc">Computes congestion cost and writes congested lines to specified file. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:594</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a03c901da8d2613290d2bcf817d0cf8f1"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a03c901da8d2613290d2bcf817d0cf8f1">decoop::CoopBendersAlgorithm::fx_p_plant_var_</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; GRBVar &gt; &gt; fx_p_plant_var_</div><div class="ttdoc">Power profile variables in the fixed OPF model. Outer vector is plantbusses, inner is timesteps...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:53</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html">decoop::CoopBendersAlgorithm</a></div><div class="ttdoc">Implements the decomposition algorithm. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:36</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a328ca9773c8a16d2eb691ebcede82779"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a328ca9773c8a16d2eb691ebcede82779">decoop::CoopBendersAlgorithm::SolveSerial</a></div><div class="ttdeci">void SolveSerial(const std::vector&lt; std::pair&lt; SubIterator, SubIterator &gt;&gt; &amp;iterators)</div><div class="ttdoc">Solves specified subproblems serially. </div><div class="ttdef"><b>Definition:</b> coopBendersSolveNCutgen.cpp:47</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a792854e54bf5ef487e0249dae0b559e2"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a792854e54bf5ef487e0249dae0b559e2">decoop::CoopBendersAlgorithm::tot_flex_power_</a></div><div class="ttdeci">const double tot_flex_power_</div><div class="ttdoc">Total flexible load on all busses. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:74</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a2fda073032c513522de1419fcad7411b"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a2fda073032c513522de1419fcad7411b">decoop::CoopBendersAlgorithm::UpdatePowSugg</a></div><div class="ttdeci">void UpdatePowSugg()</div><div class="ttdoc">Updates power suggestion in subproblems based on last master solution. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:295</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a5c3efb6d12ba6b388925891b1a93cd77"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a5c3efb6d12ba6b388925891b1a93cd77">decoop::CoopBendersAlgorithm::get_tau</a></div><div class="ttdeci">double get_tau() const </div><div class="ttdoc">Returns current tau threshold. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:497</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a662b2c852f4d89685c0424de36662196"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a662b2c852f4d89685c0424de36662196">decoop::CoopBendersAlgorithm::detectable_opt_gap_</a></div><div class="ttdeci">double detectable_opt_gap_</div><div class="ttdoc">Detectable optimality gap. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:75</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a461c344096dee52120b02779607a81f6"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a461c344096dee52120b02779607a81f6">decoop::CoopBendersAlgorithm::fixed_model_</a></div><div class="ttdeci">GRBModel fixed_model_</div><div class="ttdoc">OPF model that fixes flexible load profiles to compute an upper bound on the cost. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:49</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a047cfe9673eaa2e1182bf0c1efb969b7"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a047cfe9673eaa2e1182bf0c1efb969b7">decoop::PriceProblem::ComputePrices</a></div><div class="ttdeci">void ComputePrices(const std::unordered_map&lt; int, double &gt; &amp;bus_data, const std::unordered_map&lt; std::string, double &gt; &amp;wd, GRBModel &amp;loadflow_in)</div><div class="ttdoc">Computes electricity prices as locational marginal cost at each bus. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:545</div></div>
<div class="ttc" id="structdecoop_1_1_algorithm_options_html"><div class="ttname"><a href="structdecoop_1_1_algorithm_options.html">decoop::AlgorithmOptions</a></div><div class="ttdoc">Processes user input from file options_algorithm.txt. </div><div class="ttdef"><b>Definition:</b> inputStructs.hpp:66</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a79e4be92dd47da7c8f53a739163cbde0"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a79e4be92dd47da7c8f53a739163cbde0">decoop::CoopBendersAlgorithm::cumul_feas_dist_</a></div><div class="ttdeci">double cumul_feas_dist_</div><div class="ttdoc">Cumulated distance to feasibility of all subproblems. Unit is MW. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:77</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ab5ccc3ab6f717685c575d48d757afaa7"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ab5ccc3ab6f717685c575d48d757afaa7">decoop::CoopBendersAlgorithm::SetUpMasterAndFixed</a></div><div class="ttdeci">void SetUpMasterAndFixed()</div><div class="ttdoc">Sets up members related to master and fixed OPF problems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:28</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_ad4bebc3c8d302de0ac70da6ac1f5f61d"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#ad4bebc3c8d302de0ac70da6ac1f5f61d">decoop::PriceProblem::timesteps_</a></div><div class="ttdeci">unsigned timesteps_</div><div class="ttdoc">Number of timesteps in the model. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:364</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a8d27a3623a0151e24e4bb170e7e056dc"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a8d27a3623a0151e24e4bb170e7e056dc">decoop::CoopBendersAlgorithm::SolveAndGenerateCutParallel</a></div><div class="ttdeci">void SolveAndGenerateCutParallel(const int iteration, const std::vector&lt; std::pair&lt; SubIterator, SubIterator &gt;&gt; &amp;iterators)</div><div class="ttdoc">Solves specified subproblems and generates a cut for each one in parallel. </div><div class="ttdef"><b>Definition:</b> coopBendersSolveNCutgen.cpp:232</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aabf3a8b928c41ed94cd2245d55e62015"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aabf3a8b928c41ed94cd2245d55e62015">decoop::CoopBendersAlgorithm::get_tot_flex_power</a></div><div class="ttdeci">double get_tot_flex_power() const </div><div class="ttdoc">Returns total flexible cooperating load in MW. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:493</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aa0df6429c2226e849c6afe0ed66962b2"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aa0df6429c2226e849c6afe0ed66962b2">decoop::CoopBendersAlgorithm::sub_prob_</a></div><div class="ttdeci">std::vector&lt; SubVariant &gt; sub_prob_</div><div class="ttdoc">Vector holding the subproblem objects, each entry can hold either a CW or L1 problem. Holds all primary and secondary problems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:57</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a40fed2e5a31289fc5fb613d532df2711"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a40fed2e5a31289fc5fb613d532df2711">decoop::CoopBendersAlgorithm::CreateSubproblemObjects</a></div><div class="ttdeci">double CreateSubproblemObjects(const std::string &amp;workspace_path, const std::unordered_map&lt; int, double &gt; &amp;bus_data, const SubproblemType sp_type, const bool add_environments)</div><div class="ttdoc">Fills vectors sub_prob_ and pb_info_ and computes total flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:138</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a3a2a06aa945eaaadaa80a814bd8187ce"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a3a2a06aa945eaaadaa80a814bd8187ce">decoop::PriceProblem::price_env_</a></div><div class="ttdeci">GRBEnv price_env_</div><div class="ttdoc">Environment for model. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:360</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a8a4e0ef0a28b311a50ed9d42c9a24b5e"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a8a4e0ef0a28b311a50ed9d42c9a24b5e">decoop::PriceProblem::price_vars_</a></div><div class="ttdeci">DynArrayRAIIWrapper&lt; GRBVar &gt; price_vars_</div><div class="ttdoc">All variables contained in the model loadflow_price_. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:362</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a105c1b42dfedd9ee5898844421debf7d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a105c1b42dfedd9ee5898844421debf7d">decoop::CoopBendersAlgorithm::get_time_master_stage</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; get_time_master_stage() const </div><div class="ttdoc">Returns total time spent in the master stage of the algorithm. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:473</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aab973a4391362d9e4bfd62a1c749c992"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aab973a4391362d9e4bfd62a1c749c992">decoop::CoopBendersAlgorithm::feas_begin_</a></div><div class="ttdeci">SubIterator feas_begin_</div><div class="ttdoc">Iterator to beginning of problems used for computing feasibility distance in sub_prob_ vector...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:64</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a3fbdc2d0f7bdfb301539ca6cde9dd891"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a3fbdc2d0f7bdfb301539ca6cde9dd891">decoop::PriceProblem::plantbusses_</a></div><div class="ttdeci">std::vector&lt; std::pair&lt; int, double &gt; &gt; plantbusses_</div><div class="ttdoc">Contains bus numbers of cooperating busses as well as flexible load fractions. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:363</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_afe2b949283c56ad246f1bfe6827d94ec"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#afe2b949283c56ad246f1bfe6827d94ec">decoop::CoopBendersAlgorithm::time_feas_pt_stage_</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; time_feas_pt_stage_</div><div class="ttdoc">Total time finding feasible points. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:81</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a6cb573720b0dfe705555e2bcd4d31e2d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a6cb573720b0dfe705555e2bcd4d31e2d">decoop::CoopBendersAlgorithm::GetInitialTau</a></div><div class="ttdeci">double GetInitialTau() const </div><div class="ttdoc">Returns initial tau factor as specified in option file. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:514</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a75f36dfd4cf8b3aa8f8f35a9eaff9dbd"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a75f36dfd4cf8b3aa8f8f35a9eaff9dbd">decoop::CoopBendersAlgorithm::get_accepted_cost</a></div><div class="ttdeci">double get_accepted_cost() const </div><div class="ttdoc">Returns accepted cost of the OPF problem at found solution. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:509</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ac360a0d07a61e7d722d0f0e5f0c48114"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ac360a0d07a61e7d722d0f0e5f0c48114">decoop::CoopBendersAlgorithm::mas_t_</a></div><div class="ttdeci">TimePoint mas_t_</div><div class="ttdoc">Time at which a master stage is started. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:83</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html"><div class="ttname"><a href="classdecoop_1_1_price_problem.html">decoop::PriceProblem</a></div><div class="ttdoc">Class used to compute prices at each bus and congestion cost. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:359</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ab2850056f50bf26762eeea9a21b86db3"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ab2850056f50bf26762eeea9a21b86db3">decoop::CoopBendersAlgorithm::SubIterator</a></div><div class="ttdeci">std::vector&lt; std::variant&lt; PlantbusSubproblemCW, PlantbusSubproblemL1 &gt;&gt;::iterator SubIterator</div><div class="ttdoc">Iterator over vector holding subproblem variants. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:39</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ada78f67d99bcf463c0bc313ba5bc2908"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ada78f67d99bcf463c0bc313ba5bc2908">decoop::CoopBendersAlgorithm::SetUpSub</a></div><div class="ttdeci">double SetUpSub(const std::string &amp;workspace_path, const std::unordered_map&lt; int, double &gt; &amp;bus_data)</div><div class="ttdoc">Sets up members related to subproblems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:52</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a38b1314f6931ffcb25160a7dd95cbf0e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a38b1314f6931ffcb25160a7dd95cbf0e">decoop::CoopBendersAlgorithm::l1_end_</a></div><div class="ttdeci">SubIterator l1_end_</div><div class="ttdoc">Iterator to end of primary L1 problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:63</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ab872e4a876ba7e0a224a901e0f86a29f"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ab872e4a876ba7e0a224a901e0f86a29f">decoop::CoopBendersAlgorithm::SubVariant</a></div><div class="ttdeci">std::variant&lt; PlantbusSubproblemCW, PlantbusSubproblemL1 &gt; SubVariant</div><div class="ttdoc">Variant that holds either subproblem type. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:38</div></div>
<div class="ttc" id="coop_benders_subproblem_c_w_8hpp_html"><div class="ttname"><a href="coop_benders_subproblem_c_w_8hpp.html">coopBendersSubproblemCW.hpp</a></div><div class="ttdoc">Header file for PlantbusSubproblemCW class. </div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a4da41d025e2f42ac7a5e1d94e64a7124"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a4da41d025e2f42ac7a5e1d94e64a7124">decoop::CoopBendersAlgorithm::get_pb_info</a></div><div class="ttdeci">std::vector&lt; PlantbusInfo &gt; get_pb_info()</div><div class="ttdoc">Returns vector containing further information on each plantbus. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:445</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a2cf621a6dc5cc81e7b5e27490931c87d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a2cf621a6dc5cc81e7b5e27490931c87d">decoop::CoopBendersAlgorithm::options_</a></div><div class="ttdeci">const AlgorithmOptions options_</div><div class="ttdoc">Holds options specified by user in option file. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:48</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a84b98519deb53dfe9d3f12c4f2c30550"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a84b98519deb53dfe9d3f12c4f2c30550">decoop::CoopBendersAlgorithm::master_p_plant_var_</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; GRBVar &gt; &gt; master_p_plant_var_</div><div class="ttdoc">Power profile variables in the master OPF model. Outer vector is plantbusses, inner is timesteps...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:54</div></div>
<div class="ttc" id="classdecoop_1_1_price_problem_html_a33a5b2ffb50f97497c031fa742e7a1d3"><div class="ttname"><a href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3">decoop::PriceProblem::loadflow_price_</a></div><div class="ttdeci">GRBModel loadflow_price_</div><div class="ttdoc">Model used to compute prices. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:361</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_abb47e102a47591ccadccb6240f829f1f"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#abb47e102a47591ccadccb6240f829f1f">decoop::CoopBendersAlgorithm::get_num_timesteps</a></div><div class="ttdeci">unsigned get_num_timesteps() const </div><div class="ttdoc">Returns number of timesteps in the model. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:433</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a94a58af248928ad4a8e0f7f14e7c4a6d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a94a58af248928ad4a8e0f7f14e7c4a6d">decoop::CoopBendersAlgorithm::TimePoint</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::steady_clock &gt; TimePoint</div><div class="ttdoc">Time point for measuring exection times. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:40</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a4c91e62375c1b3fb2bdefd25eed747f6"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a4c91e62375c1b3fb2bdefd25eed747f6">decoop::CoopBendersAlgorithm::secondary_end_</a></div><div class="ttdeci">SubIterator secondary_end_</div><div class="ttdoc">Iterator to end of secondary problems in sub_prob_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:67</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a46f9fb3764cd041717fda27e7b80222a"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a46f9fb3764cd041717fda27e7b80222a">decoop::CoopBendersAlgorithm::coop_sol_available_</a></div><div class="ttdeci">const bool coop_sol_available_</div><div class="ttdoc">Indicates whether or not a cooperative (i.e. integrated) solution is available. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:92</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_afa5055545de115444304ee759e6cc27b"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#afa5055545de115444304ee759e6cc27b">decoop::CoopBendersAlgorithm::SubStage</a></div><div class="ttdeci">void SubStage(const int iteration)</div><div class="ttdoc">Solves all subproblems and generates cuts. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:186</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a04ce878ed930f13a1d0c3f6437d8aa6e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a04ce878ed930f13a1d0c3f6437d8aa6e">decoop::CoopBendersAlgorithm::accepted_cost_</a></div><div class="ttdeci">double accepted_cost_</div><div class="ttdoc">Accepted OPF cost. Cost either satisfies user-defined optimality gap, or, if not converged, cost of last suggestion, which is lower bound for optimal cost. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:76</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a5a27c785922631e08e5d8bd3fe729d88"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a5a27c785922631e08e5d8bd3fe729d88">decoop::CoopBendersAlgorithm::get_time_sub_stage</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; get_time_sub_stage() const </div><div class="ttdoc">Returns total time spent in the subproblem stage of the algorithm. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:477</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ae57276e89bdb013509f1e93d80432c58"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ae57276e89bdb013509f1e93d80432c58">decoop::CoopBendersAlgorithm::SubproblemType</a></div><div class="ttdeci">SubproblemType</div><div class="ttdoc">Used to determine what type of subproblem to create in CreateSubproblemObjects. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:45</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_ac68e0694ba0edf51459909d03c520ac0"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#ac68e0694ba0edf51459909d03c520ac0">decoop::CoopBendersAlgorithm::time_master_stage_</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; time_master_stage_</div><div class="ttdoc">Total master stage time. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:80</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a525aec2b531f79d2f9703c20030a25ff"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a525aec2b531f79d2f9703c20030a25ff">decoop::CoopBendersAlgorithm::get_detectable_opt_gap</a></div><div class="ttdeci">double get_detectable_opt_gap() const </div><div class="ttdoc">Returns optimality gap at solution. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:505</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a851caba22a1246d0878ad1e20890bda6"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a851caba22a1246d0878ad1e20890bda6">decoop::CoopBendersAlgorithm::master_model_</a></div><div class="ttdeci">GRBModel master_model_</div><div class="ttdoc">OPF model that suggests power profiles for subproblems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:50</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a1366732fe42398feff835ff2ef263555"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a1366732fe42398feff835ff2ef263555">decoop::CoopBendersAlgorithm::converged_</a></div><div class="ttdeci">bool converged_</div><div class="ttdoc">Indicates whether or not the algorithm has converged. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:91</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a5cd869b4eacbf161ad1cd4268d35e33e"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a5cd869b4eacbf161ad1cd4268d35e33e">decoop::CoopBendersAlgorithm::GenerateCut</a></div><div class="ttdeci">void GenerateCut(const int iteration, const std::vector&lt; std::pair&lt; SubIterator, SubIterator &gt;&gt; &amp;iterators)</div><div class="ttdoc">Generates cuts for specified subproblems serially. </div><div class="ttdef"><b>Definition:</b> coopBendersSolveNCutgen.cpp:61</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a560de44bf20cf42b93efd2abae4f3e1d"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a560de44bf20cf42b93efd2abae4f3e1d">decoop::CoopBendersAlgorithm::time_sub_cutgen_</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; time_sub_cutgen_</div><div class="ttdoc">Total time in subproblem stage spent generating cuts. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:88</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a7f1f5049a7a71ab722dca7e17626e758"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a7f1f5049a7a71ab722dca7e17626e758">decoop::CoopBendersAlgorithm::Iterate</a></div><div class="ttdeci">void Iterate()</div><div class="ttdoc">Runs the algorithm. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:378</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a945b1012a8ad61d60715c37cce70349f"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a945b1012a8ad61d60715c37cce70349f">decoop::CoopBendersAlgorithm::time_sub_solving_</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; time_sub_solving_</div><div class="ttdoc">Total time in subproblem stage spent solving subproblems. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:87</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a025ed34f322183043be8ac4026d42334"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a025ed34f322183043be8ac4026d42334">decoop::CoopBendersAlgorithm::get_time_sub_solving</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; get_time_sub_solving() const </div><div class="ttdoc">Returns total time spent solving subproblems within the subproblem stage. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:485</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_abb7a97bf70acb0771e469e02e15603c5"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#abb7a97bf70acb0771e469e02e15603c5">decoop::CoopBendersAlgorithm::pb_info_</a></div><div class="ttdeci">std::vector&lt; PlantbusInfo &gt; pb_info_</div><div class="ttdoc">One entry per plantbus, since information in SubproblemInfo is applicable to all subproblems on a pla...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:58</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a812e51690eef89b5cf1a3a9eb2290f59"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a812e51690eef89b5cf1a3a9eb2290f59">decoop::CoopBendersAlgorithm::get_time_sub_cutgen</a></div><div class="ttdeci">std::chrono::duration&lt; double &gt; get_time_sub_cutgen() const </div><div class="ttdoc">Returns total time spent generating cuts within the subproblem stage. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:489</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_aa8d7a3c3def380194aa810c3bb131634"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#aa8d7a3c3def380194aa810c3bb131634">decoop::CoopBendersAlgorithm::final_iters_</a></div><div class="ttdeci">int final_iters_</div><div class="ttdoc">Final number of iterations performed. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:72</div></div>
<div class="ttc" id="classdecoop_1_1_dyn_array_r_a_i_i_wrapper_html"><div class="ttname"><a href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper&lt; GRBVar &gt;</a></div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a4d112a3a98269ffef46c6b7c17435858"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a4d112a3a98269ffef46c6b7c17435858">decoop::CoopBendersAlgorithm::sub_cutgen_t_</a></div><div class="ttdeci">TimePoint sub_cutgen_t_</div><div class="ttdoc">Time at which cut generation is started during a single subproblem stage. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:90</div></div>
<div class="ttc" id="plantbus_info_8hpp_html"><div class="ttname"><a href="plantbus_info_8hpp.html">plantbusInfo.hpp</a></div><div class="ttdoc">Header file for PlantbusInfo class. </div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a43a1614812a29d730257cf166f36ac30"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a43a1614812a29d730257cf166f36ac30">decoop::CoopBendersAlgorithm::sub_t_</a></div><div class="ttdeci">TimePoint sub_t_</div><div class="ttdoc">Time at which a subproblem stage is started. </div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.hpp:85</div></div>
<div class="ttc" id="classdecoop_1_1_coop_benders_algorithm_html_a90848269dce6641b7a01e1edaee8a151"><div class="ttname"><a href="classdecoop_1_1_coop_benders_algorithm.html#a90848269dce6641b7a01e1edaee8a151">decoop::CoopBendersAlgorithm::PrintActiveCuts</a></div><div class="ttdeci">void PrintActiveCuts()</div><div class="ttdoc">Writes all cuts added by subproblems that are active in the current solution to output txt file...</div><div class="ttdef"><b>Definition:</b> coopBendersAlgorithm.cpp:522</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
